#include <QStyleFactory>
void Form1::Init()
{
	if ( !once )
	{
		ui.setupUi(this);
		ui.currPageB->setVisible( false );
		ui.dwnW->setVisible( false );
		connect( ui.searchB, SIGNAL( clicked() ), this, SLOT( searchB() ) );
		connect( ui.titleE, SIGNAL( returnPressed() ), this, SLOT( searchB() ) );
		connect( ui.prevB, SIGNAL( clicked() ), this, SLOT( prevB() ) );
		connect( ui.nextB, SIGNAL( clicked() ), this, SLOT( nextB() ) );
		connect( ui.clrB, SIGNAL( clicked() ), this, SLOT( clrB() ) );
		connect( ui.titlesW, SIGNAL( cellDoubleClicked(int,int) ), this, SLOT( playB() ) );
		connect( ui.playB, SIGNAL( clicked() ), this, SLOT( playB() ) );
		connect( ui.downloadB, SIGNAL( clicked() ), this, SLOT( downloadB() ) );
		connect( ui.currPageB, SIGNAL( editingFinished() ), this, SLOT( setPage() ) );
		connect( ui.abortB, SIGNAL( clicked() ), this, SLOT( abortB() ) );
		connect( &timRef, SIGNAL( timeout() ), this, SLOT( timeOut() ) );
		connect( ui.titlesW, SIGNAL( customContextMenuRequested(QPoint) ), this, SLOT( mnuTPopup() ) );
		connect( ui.queueW, SIGNAL( customContextMenuRequested(QPoint) ), this, SLOT( mnuQPopup() ) );
		connect( ui.dwnPB, SIGNAL( clicked() ), this, SLOT( dwnPB() ) );
		connect( this, SIGNAL( infoLUpdated( QString ) ), this, SLOT( updateInfoL( QString ) ) );

		fl.ui.setupUi(&fl);
		connect( fl.ui.defaultB, SIGNAL( clicked() ), &fl, SLOT( defaultB() ) );
		connect( fl.ui.closeB, SIGNAL( clicked() ), &fl, SLOT( close() ) );
	}
	Save.odczytajopcje();
	if ( !once )
	{
		connect( ui.pageWrzutaB, SIGNAL( toggled(bool) ), this, SLOT( chPage(bool) ) );
		connect( ui.page4sharedB, SIGNAL( toggled(bool) ), this, SLOT( chPage(bool) ) );
		connect( ui.pageYouTubeB, SIGNAL( toggled(bool) ), this, SLOT( chPage(bool) ) );
	}
	once = true;
}

void Form1::updateInfoL( QString s )
{
	f1.ui.infoL->setText( s );
}

void Form1::chPage(bool b)
{
	if ( !b )
		return;
	Save.zapiszopcje();
	clrB();
}

void Form1::dwnPB()
{
	QString pth2 = QLib->fileDialog( OPEN_DIR, this, Texts[0] /* "Wyierz sciezke do zapisu" */, pth, "", NULL )[0];
	if ( !pth2.isEmpty() && QFile::exists( pth2 ) )
	{
		pth = pth2;
		Save.zapiszopcje();
	}
}

void Form1::resizeEvent( QResizeEvent * )
{
	int W = f1.ui.titlesW->width();
	int hW = f1.ui.titlesW->verticalHeader()->sizeHint().width() + 22;
	int titleW = 0.55 * (double)W;
	int othW = 0.15 * (double)W;
	f1.ui.titlesW->setColumnWidth( 0, titleW );
	f1.ui.titlesW->setColumnWidth( 1, othW - hW/2 );
	f1.ui.titlesW->setColumnWidth( 2, othW - hW/2 );
	f1.ui.titlesW->setColumnWidth( 3, othW );
}

QImage getImg( QString URL )
{
	URL_FILE *f = url_fopen( URL.toAscii() );
	bool error = false;
	QImage img;
	if ( f )
	{
		uchar *data = NULL;
		char *tmp = new char[ 4096 ];
		uint size = 0;
		int ile = MAX_ILE;
		uint bread(0);
		while ( !url_feof( f ) )
		{
			bread = url_fread( tmp, 1, 4096, f );

			if ( !bread && !url_feof( f ) && !--ile )
			{
				error = true;
				break;
			}
			if ( bread )
				ile = MAX_ILE;

			size += bread;
			data = (uchar *)realloc( data, size * sizeof( uchar ) );
			memcpy( data + size - bread, tmp, bread * sizeof( uchar ) );
		}
		delete[] tmp;
		img = QImage::fromData( data, size );
		free( data );
		url_fclose( f );
	}
	else
		error = true;
	if ( error )
		return QImage();
	else
		return img;
}

#include "readers.h"

const int LISTA_MAX = 6;
QStringList lista[ LISTA_MAX ];
QList<QImage> listaObrazkow;
int currPage, maxPages, lastMaxPages;
QString address;

struct searchThr : public QThread
{
	public:
		searchThr()
		{
			connect( this, SIGNAL( finished() ), &f1, SLOT( searchAddressAfterThr() ) );
		}
		void run()
		{
			breakThr = false;

			QString tmpAddr;
			if ( firstPage )
				currPage = 1;
			if ( f1.ui.page4sharedB->isChecked() )
				tmpAddr = address + QString::number( currPage * 10 - 10 );
			else
				tmpAddr = address + QString::number( currPage );
			f1.clr2();

			f = url_fopen( tmpAddr.toAscii() );
			if ( f )
			{
				char *data = new char[ 4096 ];
				int ile = MAX_ILE;
				uint bread(0);
				error = false;
				while ( !url_feof( f ) )
				{
					if ( breakThr )
					{
						delete[] data;
						url_fclose( f );
						f1.clr2();
						return;
					}
					bread = url_fread( data, 1, 4096, f );

					if ( !bread && !url_feof( f ) && !--ile )
					{
						error = true;
						break;
					}
					if ( bread )
						ile = MAX_ILE;

					for ( uint i = 0 ; i < bread ; i++ )
						xmlStr += data[i];
				}
				delete[] data;
				url_fclose( f );

				QStringList ( *Split )( QString ) = NULL;
				QString ( *getData )( QString, DataType ) = NULL;
				if ( f1.ui.pageWrzutaB->isChecked() )
				{
					Split = _WrzutaReader::Split;
					getData= _WrzutaReader::getData;
				}
				else if ( f1.ui.page4sharedB->isChecked() )
				{
					Split = _4SharedReader::Split;
					getData= _4SharedReader::getData;
				}
				else if ( f1.ui.pageYouTubeB->isChecked() )
				{
					Split = _YouTubeReader::Split;
					getData= _YouTubeReader::getData;
				}
				QStringList list = Split( xmlStr );
				xmlStr.clear();
				maxPages = list[0].toInt();
				for ( int i = 1 ; i < list.count() ; i++ )
				{
					if ( breakThr )
					{
						list.clear();
						f1.clr2();
						return;
					}

					lista[NAME] += getData( list[i], NAME );
					lista[FSIZE] += getData( list[i], FSIZE );
					f1.infoL( Texts[20] + " " + QString::number( i ) + " / " + QString::number( list.count()-1 ) );
					if ( f1.ui.page4sharedB->isChecked() )
						lista[FURL] += f1.getMusAddr( getData( list[i], FURL ) );
					else
						lista[FURL] += getData( list[i], FURL );
					lista[USERNAME] += getData( list[i], USERNAME );
					lista[LENGTH] += getData( list[i], LENGTH );
					lista[PURL] += getData( list[i], PURL );
					if ( f1.ui.pageYouTubeB->isChecked() && showImgs )
						listaObrazkow += getImg( getData( list[i], IMAGE ) );
				}
				list.clear();
			}
			else
				error = true;
		}
		bool error, breakThr, firstPage;
		URL_FILE *f;
		QString xmlStr;
} searchThr;

void Form1::breakThr()
{
	if ( searchThr.isRunning() )
	{
		searchThr.breakThr = true;
		searchThr.wait( 2000 );
		if ( searchThr.isRunning() )
		{
			searchThr.terminate();
			searchThr.wait( 1000 );
		}
	}
}

void Form1::searchAddressAfterThr()
{
	unloadCURL();

	clr1();
	setUiEnabled( true );

	if ( searchThr.breakThr )
		return;

	if ( searchThr.error )
	{
		ui.infoL->setText( Texts[1] /* "Connection error!" */ );
		return;
	}

	if ( lista[NAME].count() < 1 && !maxPages )
	{
		ui.infoL->setText( Texts[2] /* "Nic nie znaleziono" */ );
		address.clear();
		return;
	}

	if ( ui.pageYouTubeB->isChecked() && showImgs )
		ui.titlesW->verticalHeader()->setDefaultSectionSize( 80 );
	else
		ui.titlesW->verticalHeader()->setDefaultSectionSize( 20 );

	ui.currPageB->setVisible( true );
	ui.currPageB->setValue( currPage );

	if ( maxPages == 0 )
		maxPages = lastMaxPages;
	if ( maxPages != -1 )
	{
		ui.pagesL->setText( " / " + QString::number( maxPages ) );
		ui.currPageB->setMaximum( maxPages );
	}
	else
	{
		if ( ui.pageWrzutaB->isChecked() )
			ui.currPageB->setMaximum( 100 );
		else
			ui.currPageB->setMaximum( 32767 );
	}
	ui.currPageB->setMinimum( 1 );

	ui.titlesW->setRowCount( lista[NAME].count() );
	QTableWidgetItem *tmpItem;
	for ( int i = 0 ; i < ui.titlesW->rowCount() ; i++ )
	{
		if ( ui.pageYouTubeB->isChecked() && showImgs )
			tmpItem = new QTableWidgetItem( QPixmap::fromImage( listaObrazkow[i] ), QString::fromUtf8( lista[ NAME ][i].toAscii() ) );
		else
			tmpItem = new QTableWidgetItem( QString::fromUtf8( lista[ NAME ][i].toAscii() ) );
		ui.titlesW->setItem( i, 0, tmpItem );

		tmpItem = new QTableWidgetItem( lista[ LENGTH ][i] );
		ui.titlesW->setItem( i, 1, tmpItem );

		tmpItem = new QTableWidgetItem( lista[ FSIZE ][i] );
		ui.titlesW->setItem( i, 2, tmpItem );

		tmpItem = new QTableWidgetItem( QString::fromUtf8( lista[ USERNAME ][i].toAscii() ) );
		ui.titlesW->setItem( i, 3, tmpItem );
	}

	resizeEvent( NULL );

	ui.infoL->setText( Texts[3] /* "Zaladowano!" */ );
}
void Form1::searchAddress( bool firstPage )
{
	ui.infoL->setText( "" );
	loadCURL();
	if ( !CURLloaded )
		return;
	ui.infoL->setText( Texts[20] /*Wyszukiwanie*/ );
	setUiEnabled( false );
	searchThr.firstPage = firstPage;
	searchThr.start();
}

void Form1::setUiEnabled( bool b )
{
	if ( !b )
		ui.searchB->setText( Texts[ 21 ] /*Zatrzymaj*/ );
	else
		ui.searchB->setText( Texts[ 22 ] /*Szukaj*/ );

	ui.titleE->setEnabled( b );
	ui.titlesW->setEnabled( b );
	ui.widget->setEnabled( b );
	ui.prevB->setEnabled( b );
	ui.nextB->setEnabled( b );
	ui.currPageB->setEnabled( b );
	ui.dwnPB->setEnabled( b );
	ui.clrB->setEnabled( b );
	ui.downloadB->setEnabled( b );
	ui.playB->setEnabled( b );
}

void Form1::searchB()
{
	if ( searchThr.isRunning() )
	{
		breakThr();
		return;
	}

	lastMaxPages = 0;
	if ( ui.titleE->text().isEmpty() )
	{
		ui.infoL->setText( Texts[4] /* "Puste" */ );
		return;
	}

	QString txt = QUrl::toPercentEncoding( ui.titleE->text() );
	if ( ui.pageWrzutaB->isChecked() )
		address = "http://www.wrzuta.pl/szukaj/audio/" + txt + "/";
	else if ( ui.page4sharedB->isChecked() )
		address = "http://search.4shared.com/network/search.jsp?sortType=1&sortOrder=1&sortmode=1&searchName=" + txt + "&searchmode=3&searchDescription=&searchExtention=mp3&sizeCriteria=atleast&sizevalue=10&start=";
	else if ( ui.pageYouTubeB->isChecked() )
		address = "http://www.youtube.com/results?search_query=" + txt + "&search_type=&aq=f&page=";

	searchAddress( true );
}

void Form1::prevB()
{
	if ( currPage > 1 && !address.isEmpty() )
	{
		currPage--;
		searchAddress( false );
	}
}
void Form1::nextB()
{
	if ( ( ( currPage < maxPages && maxPages != -1 ) || maxPages == -1 ) && !address.isEmpty() )
	{
		currPage++;
		searchAddress( false );
	}
}
void Form1::setPage()
{
	if ( ui.currPageB->isVisible() && ui.currPageB->hasFocus() )
	{
		currPage = ui.currPageB->value();
		searchAddress( false );
	}
}

void Form1::clrB()
{
	if ( ui.clrB->hasFocus() )
		address.clear();
	clr1();
	clr2();
}
void Form1::clr1()
{
	for ( int i = 0 ; i < ui.titlesW->rowCount() ; i++ )
	{
		delete ui.titlesW->item( i, 0 );
		delete ui.titlesW->item( i, 1 );
		delete ui.titlesW->item( i, 2 );
		delete ui.titlesW->item( i, 3 );
	}
	ui.titlesW->setRowCount( 0 );
	ui.pagesL->setText( "" );
	ui.infoL->setText( "" );
	ui.currPageB->setVisible( false );
}
void Form1::clr2()
{
	lastMaxPages = maxPages;
	maxPages = -1;
	for ( int i = 0 ; i < LISTA_MAX ; i++ )
		lista[i].clear();
	listaObrazkow.clear();
}

void Form1::downloadB()
{
	if ( ui.titlesW->currentRow() < 0 )
		return;
	qApp->setOverrideCursor( QCursor( Qt::WaitCursor ) );
	QString ext, Addr;
	if ( ui.pageYouTubeB->isChecked() )
	{
		ext = ".flv";
		Addr = getMusAddr( lista[FURL][ ui.titlesW->currentRow() ] );
		if ( Addr.contains( "itag=18" ) || Addr.contains( "itag=22" ) || Addr.contains( "itag=37" ) )
			ext = ".mp4";
	}
	else if ( ui.pageWrzutaB->isChecked() )
	{
		Addr = getMusAddr( lista[FURL][ ui.titlesW->currentRow() ] );
		ext = ".mp3";
	}
	else if ( ui.page4sharedB->isChecked() )
		Addr = lista[FURL][ ui.titlesW->currentRow() ];

	if ( ui.titlesW->currentRow() > -1 && ui.titlesW->rowCount() > 0 )
		ui.queueW->addItem( QString::fromUtf8( lista[NAME][ ui.titlesW->currentRow() ].toAscii() ) + ext + " -> " + Addr );

	if ( !dwnThr.isRunning() && ui.queueW->count() > 0 )
	{
		dwnThr.start();
		timRef.start( 250 );
		ui.dwnW->setVisible( true );
	}
	qApp->restoreOverrideCursor();
}

QString timeFormat( int pltime )
{
	if ( pltime < 0 )
		return "??:??";
	QString qTim,qSek,qMin;
	int sek,min,hour;

	sek = pltime % 60;
	min = pltime / 60;

	if (min < 10)
		qMin = "0" + QString::number(min);
	else if (min < 60)
		qMin = QString::number(min);
	else if (min >= 60)
	{
		hour = min / 60;
		min = min % 60;

		if (min < 10)
			qMin = "0" + QString::number(min);
		else if (min < 60)
			qMin = QString::number(min);

		qMin = QString::number(hour) + " : " + qMin;
	}

	if (sek < 10)
		qSek = "0" + QString::number(sek);
	else
		qSek = QString::number(sek);

	qTim = qMin + " : " + qSek ;

	return qTim;
}

void Form1::timeOut()
{
	if ( ui.queueW->count() < 1 )
	{
		timRef.stop();
		ui.dwnW->setVisible( false );
		dwnThr.pC  = dwnThr.spd = dwnThr.rem = dwnThr.siz = dwnThr.dwn = 0;
		ui.dwnInfoL->setText("");
		ui.dwnTitleL->setText("");
		ui.progressB->setValue( 0 );
		if ( dwnThr.isRunning() )
		{
			dwnThr.wait(1000);
			dwnThr.terminate();
		}
		return;
	}

	ui.progressB->setValue( dwnThr.pC );
	QString dwnInfo = Texts[7] /* "Speed: " */ + QString::number( dwnThr.spd / 1024 ) + "kB/s";
	if ( dwnThr.spd )
		dwnInfo += " ; " + Texts[14] /* Pozostalo */ + ": " + QString::number( dwnThr.rem / 1024 ) + "kB" + " ( " + timeFormat( dwnThr.rem / dwnThr.spd ) + " )";
	ui.dwnInfoL->setText( dwnInfo );
	ui.dwnTitleL->setText( Texts[8] /* "Downloading: " */ + ui.queueW->item(0)->text() );
}

void Form1::abortB()
{
	dwnThr.bolBr = true;
}
void Form1::abortAll()
{
	dwnThr.bolBr = dwnThr.abortAll = true;
	dwnThr.wait(2000);
	if ( dwnThr.isRunning() )
	{
		dwnThr.terminate();
		dwnThr.wait(1000);
	}
}

void Form1::playB()
{
	qApp->setOverrideCursor( QCursor( Qt::WaitCursor ) );
	QString addr = getMusAddr( "" );
	qApp->restoreOverrideCursor();
	if ( addr.isEmpty() )
	{
		ui.infoL->setText( Texts[6] /* "Blad odczytu pliku!" */ );
		return;
	}
	else if ( addr == "-" )
		return;
	if ( QLib )
	{
		QLib->control(1,0);
		QLib->addToPlayList( (QStringList)( addr ),-1 );
		QLib->lastOnList();
		QLib->control(0,0);
		ui.infoL->setText( Texts[5] /* "Dodano wpis: " */ + addr );
	}
}
void Form1::queueB()
{
	qApp->setOverrideCursor( QCursor( Qt::WaitCursor ) );
	QString addr = getMusAddr( "" );
	qApp->restoreOverrideCursor();
	if ( addr.isEmpty() )
	{
		ui.infoL->setText( Texts[6] /* "Blad odczytu pliku!" */ );
		return;
	}
	else if ( addr == "-" )
		return;
	if ( QLib )
	{
		QLib->addToPlayList( (QStringList)( addr ),-1 );
		ui.infoL->setText( Texts[5] /* "Dodano wpis: " */ + addr );
	}
}

QString Form1::getXmlStrToReadMusAddr( QString a )
{
	if ( ( ui.titlesW->currentRow() > -1 && ui.titlesW->rowCount() > 0 ) || !a.isEmpty() )
	{
		QString URL;
		if ( a.isEmpty() )
			URL = lista[FURL][ ui.titlesW->currentRow() ];
		else
			URL = a;
		loadCURL();
		if ( !CURLloaded )
			return "";
		bool error = false;
		QString xmlStr;
		URL_FILE *f = url_fopen( URL.toAscii() );
		if (f)
		{
			char *data = new char[ 4096 ];
			int ile = MAX_ILE;
			uint bread(0);
			while ( !url_feof(f) )
			{
				bread = url_fread( data, 1, 4096, f );

				if ( !bread && !url_feof( f ) && !--ile )
				{
					error = true;
					break;
				}
				if ( bread )
					ile = MAX_ILE;

				for ( uint i = 0 ; i < bread ; i++ )
					xmlStr += data[i];
			}
			delete[] data;
			url_fclose( f );
		}
		else
			error = true;
		unloadCURL();

		if ( error )
			return "";
		else
			return xmlStr;
	}
	return "-";
}

QString Form1::getMusAddr( QString a )
{
	if ( ui.page4sharedB->isChecked() && a.isEmpty() )
		return lista[FURL][ ui.titlesW->currentRow() ];
	QString xmlStr = getXmlStrToReadMusAddr( a );
	if ( xmlStr.count() < 2 )
		return xmlStr;

	QString ( *getFileURL )( QString ) = NULL;
	if ( ui.pageWrzutaB->isChecked() )
		getFileURL = _WrzutaReader::getFileURL;
	else if ( ui.page4sharedB->isChecked() )
		getFileURL = _4SharedReader::getFileURL;
	else if ( ui.pageYouTubeB->isChecked() )
		getFileURL = _YouTubeReader::getFileURL;

	return QUrl::fromPercentEncoding( getFileURL( xmlStr ).toAscii() );
}

void Form1::copyAddr()
{
	if ( ui.titlesW->currentRow() > -1 && ui.titlesW->rowCount() > 0 )
		qApp->clipboard()->setText( getMusAddr( "" ) );
}

void Form1::delQueueEntry()
{
	if ( ui.queueW->currentRow() > -1 && ui.queueW->count() > 0 )
	{
		if ( ui.queueW->currentRow() == 0 )
			dwnThr.bolBr = true;
		else
			ui.queueW->removeItemWidget( ui.queueW->takeItem( ui.queueW->currentRow() ) );
	}
}

void Form1::toggleShowImages()
{
	showImgs = !showImgs;
	Save.zapiszopcje();
	if ( !ui.titleE->text().isEmpty() && ui.titlesW->rowCount() > 0 )
		searchB();
}
void Form1::showQualityList()
{
	fl.createList();
	fl.exec();
	if ( fl.ui.listWidget->count() != YouTubeQualityCount )
		return;
	for ( int i = 0 ; i < YouTubeQualityCount ; i++ )
		YouTubeQualityList[ 1 ][ i ] = QString::number( YouTubeQualityList[ 0 ].indexOf( fl.ui.listWidget->item( i )->text() ) );
	Save.zapiszopcje();
}
void Form1::showStreamQualityList()
{
	int _YouTubeQuality[ YouTubeQualityCount ];
	if ( !_YouTubeReader::getYouTubeAddr( getXmlStrToReadMusAddr( "" ), _YouTubeQuality ).count() )
		return;
	QString Quality;
	for ( int i = 0 ; i < YouTubeQualityCount ; i++ )
	{
		if ( _YouTubeQuality[i] > -1 )
		{
			if ( !Quality.isEmpty() )
				Quality += '\n';
			Quality += YouTubeQualityList[0][i];
		}
	}
	QMessageBox::information( this, Texts[19]/*Dostępne jakości*/, Quality );
}

void Form1::openInBrowser()
{
	QLib->open( lista[PURL][ ui.titlesW->currentRow() ] );
}

void Form1::mnuTPopup()
{
	mnuT.clear();

	bool show = false;

	if ( ui.titlesW->currentRow() > -1 && ui.titlesW->rowCount() > 0 )
	{
		mnuT.addAction( Texts[10] /*"Odtwarzaj"*/, this, SLOT( playB() ) );
		mnuT.addAction( Texts[16] /*"Kolejkuj"*/, this, SLOT( queueB() ) );
		mnuT.addSeparator();
		mnuT.addAction( Texts[11] /*"Pobierz"*/, this, SLOT( downloadB() ) );
		mnuT.addSeparator();
		mnuT.addAction( Texts[12] /*"Skopiuj adres"*/, this, SLOT( copyAddr() ) );
		mnuT.addSeparator();
		if ( QLib->open( "" ) )
		{
			mnuT.addAction( Texts[23] /*"Otwórz w przeglądarce"*/, this, SLOT( openInBrowser() ) );
			mnuT.addSeparator();
		}

		if ( ui.pageYouTubeB->isChecked() )
		{
			mnuT.addAction( Texts[19] /*"Dostępne jakości"*/, this, SLOT( showStreamQualityList() ) );
			mnuT.addSeparator();
		}

		show = true;
	}

	if ( ui.pageYouTubeB->isChecked() )
	{
		QAction *tmpAct = mnuT.addAction( Texts[17] /*"Pokazuj obrazki"*/, this, SLOT( toggleShowImages() ) );
		tmpAct->setCheckable( true );
		tmpAct->setChecked( showImgs );
		mnuT.addSeparator();
		tmpAct = mnuT.addAction( Texts[18] /*"Jakość odtwarzania"*/, this, SLOT( showQualityList() ) );
		show = true;
	}

	if ( show )
		mnuT.popup( QCursor::pos() );
}
void Form1::mnuQPopup()
{
	mnuQ.clear();
	if ( ui.queueW->currentRow() > -1 && ui.queueW->count() > 0 )
	{
		mnuQ.addAction( Texts[12] /*"Skopiuj adres"*/, this, SLOT( copyAddr2() ) );
		mnuQ.addSeparator();
		mnuQ.addAction( Texts[9] /* "Usun wpis" */, this, SLOT( delQueueEntry() ) );
		mnuQ.popup( QCursor::pos() );
	}
}

void Form1::copyAddr2()
{
	if ( ui.queueW->currentRow() > -1 && ui.queueW->count() > 0 )
		qApp->clipboard()->setText( ui.queueW->item( ui.queueW->currentRow() )->text().split( " -> " )[1] );
}
