enum DataType
{
	NAME, FSIZE, FURL, PURL, USERNAME, LENGTH, IMAGE
};

void chkName( QString &name )
{
	name = QTextDocumentFragment::fromHtml( QTextDocumentFragment::fromHtml( name ).toPlainText() ).toPlainText();
}

namespace _WrzutaReader
{
	QString getData( QString page, DataType type )
	{
		QString str1;
		QString str2;
		QString str3;
		switch ( type )
		{
			case FSIZE:
				str1 = "<div class=\"more\"><b>";
				str2 = "</b> | <b>";
				str3 = "<";
				break;
			case NAME:
				str1 = "<a href=\"";
				str2 = ">";
				str3 = "</a>";
				break;
			case FURL: case PURL:
				str1 = "<a href=\"";
				str3 = "\"";
				break;
			case USERNAME:
				str1 = "<div class=\"author\">";
				str2 = ">";
				str3 = "</a>";
				break;
			case LENGTH:
				str1 = "<div class=\"more\"><b>";
				str3 = "</b>";
				break;
			case IMAGE:
				return "";
		};
		int pos = page.indexOf( str1 );
		if ( pos < 0 )
			return "";
		pos += str1.length();
		if ( !str2.isEmpty() )
		{
			pos = page.indexOf( str2, pos );
			if ( pos < 0 )
				return "";
			pos += str2.length();
		}
		int len = page.indexOf( str3, pos ) - pos;
		QString ret = page.mid( pos, len );
		if ( type == FURL )
			ret.replace( "/audio/", "/sr/f/" );
		else if ( type == NAME )
			chkName( ret );
		return ret;
	}
	QString getFileURL( QString page )
	{
		QString str = "href=\"";
		int pos = page.indexOf( str );
		if ( pos < 0 )
			return "";
		pos += str.length();
		int len = page.indexOf( "\"", pos ) - pos;
		return page.mid( pos, len );
	}
	QStringList Split( QString page )
	{
		QStringList list = page.split( "<div class=\"title\">" );
		list[0].clear();

		QString str = "<em>&rsaquo;</em>";
		int pos = page.indexOf( str );
		if ( pos > -1 )
		{
			QString str2 = "<a href=\"";
			pos += str.length();
			pos = page.indexOf( str2, pos );
			pos += str2.length();
			int len = page.indexOf( "\"", pos ) - pos;
			QStringList lst = page.mid( pos, len ).split( '/' );
			list[0] = lst[ lst.count() - 1 ];
			lst.clear();
		}
		else
		{
			str = "<span class=\"active\"><a style=\"cursor:pointer;\">";
			pos = page.indexOf( str );
			if ( pos > -1 )
			{
				pos += str.length();
				int len = page.indexOf( "</a>", pos ) - pos;
				list[0] = page.mid( pos, len );
			}
		}
		return list;
	}
};

namespace _4SharedReader
{
	QString getData( QString page, DataType type )
	{
		QString str1;
		QString str2;
		QString str3;
		switch ( type )
		{
			case FSIZE:
				str1 = "<div class=\"fsize\">";
				str3 = " ";
				break;
			case NAME:
				str1 = "<div style=\"width:490px\" class=\"fname\">";
				str2 = "target=\"_blank\">";
				str3 = "</a>";
				break;
			case FURL: case PURL:
				str1 = "<div style=\"width:490px\" class=\"fname\">";
				str2 = "<a href=\"";
				str3 = "\"";
				break;
			case USERNAME:
				str1 = "<div class=\"fuser\">";
				str2 = "target=\"_blank\">";
				str3 = "</a>";
				break;
			case LENGTH:
				return "?";
			case IMAGE:
				return "";
		};
		int pos = page.indexOf( str1 );
		if ( pos < 0 )
			return "";
		pos += str1.length();
		if ( !str2.isEmpty() )
		{
			pos = page.indexOf( str2, pos );
			if ( pos < 0 )
				return "";
			pos += str2.length();
		}
		int len = page.indexOf( str3, pos ) - pos;
		QString ret = page.mid( pos, len );
		if ( type == FSIZE )
		{
			ret.replace( ',', "" );
			ret = QLib->getFSize( ret.toInt() * 1024 );
		}
		else if ( type == NAME )
			chkName( ret );
		return ret;
	}
	QString getFileURL( QString page )
	{
		QString str1 = "window.location = \"";
		int pos = page.indexOf( str1 );
		if ( pos < 0 )
			return "";
		pos += str1.length();
		int len = page.indexOf( "\"", pos ) - pos;
		return page.mid( pos, len );
	}
	QStringList Split( QString page )
	{
		QStringList list = page.split( "<tr valign=\"top\" >" );
		list[0].clear();

		QString str = "<td class=\"pager\">&nbsp;(";
		int pos = page.indexOf( str );
		if ( pos > -1 )
		{
			pos += str.length();
			int len = page.indexOf( " ", pos ) - pos;
			list[0] = QString::number( page.mid( pos, len ).toInt() / 10 + 1 );
		}
		return list;
	}
};

namespace _YouTubeReader
{
	QString getData( QString page, DataType type )
	{
		QString str1, str2, str3;
		switch ( type )
		{
			case FSIZE:
				return "?";
			case NAME:
				str1 = "title=\"";
				str3 = "\"";
				break;
			case FURL: case PURL:
				str1 = " href=\"";
				str3 = "\"";
				break;
			case USERNAME:
				return "?";
			case LENGTH:
				str1 = "class=\"video-time\"><span>";
				str3 = "</span>";
				break;
			case IMAGE:
				str1 = "thumb=\"";
				str2 = "src=\"";
				str3 = "\"";
				break;
		};
		int pos = page.indexOf( str1 );
		if ( pos < 0 )
		{
			if ( type == IMAGE )
			{
				pos = page.indexOf( str2 );
				if ( pos < 0 )
					return "";
				pos += str2.length();
			}
			else
				return "";
		}
		else
			pos += str1.length();
		int len = page.indexOf( str3, pos ) - pos;
		QString ret = page.mid( pos, len );
		if ( type == FURL || type == PURL )
			ret = "http://www.youtube.com" + ret;
		else if ( type == NAME )
			chkName( ret );
		return ret;
	}
	QStringList getYouTubeAddr( QString page, int _YouTubeQuality[ YouTubeQualityCount ] )
	{
		QString str1 = "\"fmt_stream_map\": \"";
		QString str2 = "\",";
		int pos = page.indexOf( str1 );
		if ( pos < 0 )
			return QStringList();
		pos += str1.length();
		int len = page.indexOf( str2, pos ) - pos;
		QString tmpUrl = QUrl::fromPercentEncoding( page.mid( pos, len ).toAscii() );
		tmpUrl.replace( ',', '|' );
		QStringList urlList = tmpUrl.split( '|' );
		QStringList itagList;
		for ( int i = urlList.size() - 1 ; i >= 0 ; i-- )
		{
			if ( !urlList[i].contains( "http://" ) )
			{
				itagList.prepend( urlList[ i ] );
				urlList.removeAt( i );
			}
		}
		_YouTubeQuality[ MP4_HD_1080 ] = itagList.indexOf( "37" );
		_YouTubeQuality[ MP4_HD ] = itagList.indexOf( "22" );
		_YouTubeQuality[ MP4 ] = itagList.indexOf( "18" );
		_YouTubeQuality[ FLV_HD_480 ] = itagList.indexOf( "35" );
		_YouTubeQuality[ FLV_HD_360 ] = itagList.indexOf( "34" );
		_YouTubeQuality[ FLV ] = itagList.indexOf( "5" );
		return urlList;
	}
	QString getFileURL( QString page )
	{
		int _YouTubeQuality[ YouTubeQualityCount ];
		QStringList urlList = getYouTubeAddr( page, _YouTubeQuality );
		if ( !urlList.size() )
			return "";
		for ( int i = 0 ; i < YouTubeQualityCount ; i++ )
		{
			int q = _YouTubeQuality[ YouTubeQualityList[1][i].toInt() ];
			if ( q > -1 )
				return urlList[ q ];
		}
		return "-";
	}
	QStringList Split( QString page )
	{
		QStringList list = page.split( "class=\"video-cell *sr\" style=\"width:19.5%\">" );

		list[0] = "-1";

		QString str = "class=\"name\"";
		int pos = page.indexOf( str );
		if ( pos < 0 )
			return list;
		str = " <strong>";
		pos = page.indexOf( str, pos );
		if ( pos < 0 )
			return list;
		pos += str.length();
		int len = page.indexOf( "</strong>", pos ) - pos;
		int l = page.mid( pos, len ).toInt();
		if ( l > 0 )
			list[0] = QString::number( l );
		else
			list[0] = "-1";
		return list;
	}
};
