#include <QStringList>
#include <QMessageBox>
#include <QFile>

#include "QLib.cpp"

Qmp *QLib = NULL;

char *getLine( FILE *f )
{
	char *tmpstr = (char*)malloc( sizeof(char) );
	signed char ch;
	uint len = 0;
	for(;;)
	{
		ch = getc(f);
		if ( ch == '\n' || ch == '\r' || ch == EOF )
		{
			if ( ch == '\r' )
				getc(f);
			break;
		}
		tmpstr = (char*)realloc( tmpstr, sizeof(char) * ( len + 1 ) );
		tmpstr[len] = ch;
		len++;
	}
	tmpstr = (char*)realloc( tmpstr, sizeof(char) * ( len + 1 ) );
	tmpstr[len] = '\0';
	return tmpstr;
}

char *trunc( char* c, uint t, bool b )
{
	uint len( strlen(c) );
	if ( t > len )
		t = len;
	char *tmpstr = new char[ len+1 ];
	if ( b ) //przytnij z prawej strony
	{
		strcpy( tmpstr, c );
		tmpstr[len-t] = '\0';
	}
	else //przytnij z lewej strony
	{
		uint i;
		for ( i = t ; i < len ; i++ )
			tmpstr[i-t] = c[i];
		tmpstr[i-t] = '\0';
	}
	char* tmpstr2 = new char[ strlen(tmpstr)+1 ];
	strcpy( tmpstr2, tmpstr );
	delete tmpstr;
	return tmpstr2;
}

int searchInText( char c, const char *str )
{
	uint len( strlen(str) );
	for ( uint i = 0 ; i < len ; i++ )
	{
		if ( str[i] == c )
			return i;
	}
	return -1;
}

int searchInText( char *str )
{
	uint len( strlen(str) );
	for ( uint i = 0 ; i < len ; i++ )
	{
		if ( str[i] != ' ' && str[i] != '	' )
			return i;
	}
	return -1;
}

QString getFilePathFromPlist( QString fPath, QString qpth )
{
	QString TMP = fPath;
	TMP.replace( '\\' , '/' );

	if
	(
		fPath[0] != '/' &&
		fPath[1] != ':' &&
		fPath[1] != '\\' &&
		!fPath.contains("://") &&
		QFile::exists( qpth + "/" + fPath )
	)
		TMP = qpth + "/" + fPath;

	if
	(
		( fPath[0] == '/' || fPath[1] == ':' ) &&
		!fPath.contains("://") &&
		!QFile::exists( fPath ) &&
		QFile::exists( qpth + "/" + QLib->stringOperations( PLIK_BEZ_SCIEZKI, TMP ) )
	)
		TMP = qpth + "/" + QLib->stringOperations( PLIK_BEZ_SCIEZKI, TMP );

#ifdef Q_WS_WIN
	if ( !fPath.contains("://") )
		TMP.replace( '\\' , '/' );
#endif

	return TMP;
}


void setQmpLib( Qmp *_QLib )
{
	QLib = _QLib;
}

bool load( QString selfile, QStringList *playList, QStringList *tL, bool uPLeL )
{
	QString TMP, TMP2;
	QString qpth = QLib->stringOperations( SCIEZKA_DO_PLIKU, selfile );
	uint plOK(0);

	TMP = selfile.right(4).toLower();

	if ( TMP == ".m3u" )
	{
		FILE *pF = fopen( QFile::encodeName( selfile ), "rb" );
		if ( !pF )
			return true;

		if ( !tL )
			QLib->control( 0x17, 0 );

		while( !feof(pF) )
		{
			bool BOL(0);
			char *str = getLine( pF );
			if ( !strcmp( str, "#EXTM3U" ) )
			{
				delete[] str;
				continue;
			}
			char *str4 = NULL;
			if ( !strncmp( str, "#EXTINF", 7 ) )
			{
				if ( uPLeL )
				{
					char *str2 = trunc( str, searchInText( ':', str )+1, 0 );
					TMP2 = QString::number( atoi(str2) );
					if ( TMP2.toInt() == 0 && TMP2 != "0" )
						TMP2 = "-1";
					if ( !tL )
						playList[3] += TMP2;
					char* str3 = trunc( str2, searchInText( ',', str2 )+1, 0 );
					delete[] str2;
					if ( !tL )
						playList[0] += QFile::decodeName( str3 );
					else
						*tL += QFile::decodeName( str3 );
					delete[] str3;
				}
			}
			else
			{
				str4 = str;
				BOL = 1;
			}
			if (!BOL)
				str4 = getLine( pF );
			if ( strncmp( str4, "#EXTINF", 7 ) && str4[0] != 0 )
			{
				if ( !tL )
					playList[2] += getFilePathFromPlist( QFile::decodeName( str4 ), qpth );
				else if ( tL[0][ tL->count()-1 ].isEmpty() )
					tL[0][ tL->count()-1 ] = getFilePathFromPlist( QFile::decodeName( str4 ), qpth );
			}
			if (!BOL)
				delete[] str4;
			delete[] str;
		}

		fclose(pF);

		return true;
	}

	if ( TMP == ".pls" )
	{
		FILE *pF = fopen( QFile::encodeName( selfile ) , "rb" );
		if ( !pF )
			return true;

		uint num(0), entries(0);

		while ( !feof(pF) )
		{
			char* str = getLine(pF);
			if ( plOK == 3 )
			{
				if ( !strncmp( str, "File", 4 ) )
				{
					char* str2 = trunc( str, 4, 0 );
					num = atoi(str2);
					if ( num <= entries )
					{
						char* str3 = trunc( str2, searchInText('=',str2)+1, 0 );
						delete str2;
						char* str4 = trunc( str3, searchInText(str3), 0 );
						delete str3;
						if ( !tL )
							playList[2][num-1] = getFilePathFromPlist( QFile::decodeName( str4 ), qpth );
						else
							*tL += getFilePathFromPlist( QFile::decodeName( str4 ), qpth );
						delete str4;
					}
				}
				if ( uPLeL )
				{
					if ( !strncmp( str, "Title", 5 ) )
					{
						char* str2 = trunc( str, 5, 0 );
						num = atoi(str2);
						if ( num <= entries )
						{
							char* str3 = trunc( str2, searchInText('=',str2)+1, 0 );
							delete str2;
							char* str4 = trunc( str3, searchInText(str3), 0 );
							delete str3;
							if ( !tL )
								playList[0][num-1] = QFile::decodeName( str4 );
							else
								tL[0][ tL->count()-1 ] = QFile::decodeName( str4 );
							delete str4;
						}
					}
					if ( !strncmp( str, "Length", 6 ) )
					{
						char* str2 = trunc( str, 6, 0 );
						num = atoi(str2);
						if ( num <= entries )
						{
							char* str3 = trunc( str2, searchInText('=',str2)+1, 0 );
							delete str2;
							char* str4 = trunc( str3, searchInText(str3), 0 );
							delete str3;
							TMP2 = str4;
							delete str4;
							if ( TMP2.toInt() == 0 && TMP2 != "0" )
								TMP2 = "-1";
							if ( !tL )
								playList[3][num-1] = TMP2;
						}
					}
				}
			}
			if ( plOK == 0 && !strcasecmp( str, "[playlist]" ) )
				plOK = 1;
			if ( plOK == 1 && !strncasecmp( str, "numberofentries", 15 ) )
			{
				char* str2 = trunc( str,  searchInText('=',str)+1, 0 );
				char* str3 = trunc( str2, searchInText(str2), 0 );
				delete str2;
				entries = atoi(str3);
				delete str3;
				plOK = 2;
			}
			delete str;
			if ( plOK == 2 && entries == 0 )
				break;
			if ( plOK == 2 && entries > 0 )
			{
				if ( !tL )
				{
					QLib->control( 0x17, 0 );
					for ( uint i = 0 ; i < entries ; i++ )
					{
						playList[2] += "";
						if ( uPLeL )
						{
							playList[0] += "";
							playList[3] += "";
						}
					}
				}
				plOK = 3;
				fseek(pF,0,0);
			}
		}

		fclose(pF);

		return true;
	}

	return false;
}

bool save( QString selfile, QString selfilter, QStringList *playList )
{
	QString TMP;

	if ( selfilter == "*.m3u" )
	{
		TMP = selfile.right( 4 ).toLower();
		if ( TMP != ".m3u" )
			selfile += ".m3u";

		TMP = QFile::encodeName( selfile );
		FILE *pF = fopen( TMP.toAscii(), "wb" );

		if ( !pF )
			return true;

		fprintf( pF , "#EXTM3U%c%c" , 13 , 10 );

		for ( int i = 0 ; i < playList[2].size() ; i++ )
		{
			TMP = QFile::encodeName( playList[0][i] );
			fprintf( pF , "#EXTINF:%i,%s%c%c" , playList[3][i].toInt(), TMP.toAscii().data() , 13 , 10 );
			TMP = QFile::encodeName( playList[2][i] );
			#ifdef Q_WS_WIN
			if ( !TMP.contains( "://" ) )
				TMP.replace( '/' , '\\' );
			#endif
			fprintf( pF , "%s%c%c" , TMP.toAscii().data() , 13 , 10 );
		}

		fclose(pF);

		return true;
	}

	if ( selfilter == "*.pls" )
	{
		TMP = selfile.right( 4 ).toLower();
		if ( TMP != ".pls" )
			selfile += ".pls";

		TMP = QFile::encodeName( selfile );
		FILE *pF = fopen( TMP.toAscii() , "wb" );

		if ( !pF )
			return true;

		fprintf( pF , "[playlist]%c%c" , 13 , 10 );
		fprintf( pF , "NumberOfEntries=%i%c%c" , playList[2].size()  , 13 , 10 );

		for ( int i = 0 ; i < playList[2].size() ; i++)
		{
			TMP = QFile::encodeName( playList[2][i] );
			#ifdef Q_WS_WIN
			if ( !TMP.contains( "://" ) )
				TMP.replace( '/' , '\\' );
			#endif
			fprintf( pF , "File%i=%s%c%c" , i+1, TMP.toAscii().data() , 13 , 10 );

			TMP = QFile::encodeName( playList[0][i] );
			fprintf( pF , "Title%i=%s%c%c" , i+1, TMP.toAscii().data() , 13 , 10 );
			fprintf( pF , "Length%i=%i%c%c" , i+1, playList[3][i].toInt() , 13 , 10 );
		}

		fclose(pF);

		return true;
	}

	return false;
}

bool create( QString &selfile, QString selfilter )
{
	QString TMP;

	if ( selfilter == "*.m3u" )
	{
		TMP = selfile.right( 4 ).toLower();
		if ( TMP != ".m3u" )
			selfile += ".m3u";

		TMP = QFile::encodeName( selfile );
		FILE *pF = fopen( TMP.toAscii(), "wb" );
		if ( !pF )
			return true;

		fprintf( pF, "#EXTM3U\r\n" );

		fclose(pF);

		return true;
	}

	if ( selfilter == "*.pls" )
	{
		TMP = selfile.right( 6 ).toLower();
		if ( TMP != ".pls" )
			selfile += ".pls";

		TMP = QFile::encodeName( selfile );
		FILE *pF = fopen( TMP.toAscii(), "wb" );
		if ( !pF )
			return true;

		fprintf( pF, "[playlist]\r\nNumberOfEntries=0" );

		fclose(pF);

		return true;
	}

	return false;
}

QString getExts(  )
{
	QString exts( ".m3u .pls" );
	return exts;
}

void about( QWidget *w )
{
	QMessageBox::information( w, "M3U & PLS loader", "Odczyt playlist pls i m3u" );
}

#include "PlaylistPlugin.cpp"

PluginInfo pluginInfo =
{
	"M3U & PLS loader (Playlist)",
	"PlaylistPlugin",
	1529-1,
	1.0,
	about,
	NULL,
	NULL,
	NULL,
	NULL
};

PlaylistPlugin Pplug =
{
	&pluginInfo,
	setQmpLib,
	load,
	save,
	create,
	getExts
};
