QString plikbezsciezki( QString pth )
{
	return QLib->stringOperations( PLIK_BEZ_SCIEZKI, pth );
}

void CLOSE()
{
	if ( snd )
		sf_close( snd );
	IsPlaying = false;
}

void STOP()
{
	QOut->control( QOUT_FLUSH );
	CLOSE();
	endSong=true;
}

void ERROR2( QString errStr )
{
	MUSerr = true;
	title = errStr;
}

void ERROR( QString errStr )
{
	clrPos();
	ERROR2(errStr);
	CLOSE();
}

QString getFormatStr( int format )
{
	format &= SF_FORMAT_SUBMASK;
	if ( format == SF_FORMAT_PCM_S8 )
		return "8bit signed";
	else if ( format == SF_FORMAT_PCM_16 )
		return "16bit";
	else if ( format == SF_FORMAT_PCM_24 )
		return "24bit";
	else if ( format == SF_FORMAT_PCM_32 )
		return "32bit";
	else if ( format == SF_FORMAT_PCM_U8 )
		return "8bit unsigned";
	else if ( format == SF_FORMAT_FLOAT )
		return "32bit float";
	else if ( format == SF_FORMAT_DOUBLE )
		return "64bit double";
	else if ( format == SF_FORMAT_ULAW )
		return "U-Law";
	else if ( format == SF_FORMAT_ALAW )
		return "A-Law";
	else if ( format == SF_FORMAT_IMA_ADPCM )
		return "IMA_ADPCM";
	else if ( format == SF_FORMAT_MS_ADPCM )
		return "MS_ADPCM";
	else if ( format == SF_FORMAT_GSM610 )
		return "GSM6.10";
	else if ( format == SF_FORMAT_VOX_ADPCM )
		return "VOX_ADPCM";
	else if ( format == SF_FORMAT_G721_32 )
		return "G721_32";
	else if ( format == SF_FORMAT_G723_24 )
		return "G723_24";
	else if ( format == SF_FORMAT_G723_40 )
		return "G723_40";
	else if ( format == SF_FORMAT_DWVW_12 )
		return "DWVW_12";
	else if ( format == SF_FORMAT_DWVW_16 )
		return "DWVW_16";
	else if ( format == SF_FORMAT_DWVW_24 )
		return "DWVW_24";
	else if ( format == SF_FORMAT_DWVW_N )
		return "DWVW_N";
	else if ( format == SF_FORMAT_DPCM_8 )
		return "DPCM_8";
	else if ( format == SF_FORMAT_DPCM_16 )
		return "DPCM_16";
	else if ( format == 0x0060/*SF_FORMAT_VORBIS*/ )
		return "Vorbis";
	else return "";
}

void play( const char *fileE, int type )
{
	if ( type != 0 )
		return ERROR2( QString::fromUtf8("Wtyczka obsługuje tylko odczyt plików!") );

	if ( fileE != curF )
		clrPos();

	clrSet();

	SF_INFO sndInfo;
	snd = sf_open( fileE, SFM_READ, &sndInfo );
	if ( !snd )
		return ERROR( QString::fromUtf8("Błąd odczytu pliku!") );

	curF = fileE;

	WAVUpdate( sndInfo );

	QString file = QFile::decodeName( fileE );

	if ( title.isEmpty() )
		title = plikbezsciezki( QFile::decodeName( fileE ) );

	QString bitsStr = getFormatStr( sndInfo.format );
	QOut->Init( AudioInfo( rate, 33, chn, bitsStr ), true, 0, file, title );
	if ( *QOut->PlErr )
	{
		*QOut->PlErr = false;
		return ERROR( QString::fromUtf8( "Błąd zwraca wtyczka wyjściowa!" ) );
	}

	int BUF_SIZE = 4096 * chn;

	float audio_buffer[ BUF_SIZE ];
	memset( audio_buffer, 0, BUF_SIZE * sizeof(float) );

	sf_count_t readFrames = 0;
	do
	{
		if ( bolStop )
			break;
		if ( !IsPaused && !*QOut->mustReset && !seeking )
		{
			nowReading = true;
			readFrames = sf_read_float( snd, audio_buffer, BUF_SIZE );
			nowReading = false;

			QOut->Play( audio_buffer, readFrames * sizeof(float), pltime, false );
			if ( *QOut->PlErr )
				break;

			WAVUpdate2();
		}
		else
			QOut->Play( NULL, 0, pltime, true );
	} while ( readFrames > 0 );

	STOP();
}

void getMusInfo( SNDFILE *snd, QString *title )
{
	if ( title )
	{
		const char *t = sf_get_string ( snd, SF_STR_TITLE );
		const char *a = sf_get_string ( snd, SF_STR_ARTIST );

		if ( a )
			*title += a;
		if ( t && a )
			*title += QString( " - " ) + t;
		if ( t && !a )
			*title += t;
	}
}

void WAVUpdate( SF_INFO sndInfo )
{
	getBR = "n/a";

	rate = sndInfo.samplerate;
	chn = sndInfo.channels;

	plMaxtime = sndInfo.frames / rate;
	NumPos = plMaxtime-1;

	getMusInfo( snd, &title );

	if ( savsek != 0 )
	{
		seek( savsek );
		pltime = -1;
	}
	savsek = 0;

	IsPlaying = true;
}

void WAVUpdate2()
{
	pltime = sf_seek( snd, 0, SEEK_CUR ) / rate;
	SongPos = pltime;
}

void seek( int &i )
{
	if ( i > NumPos || nowReading )
	{
		i = -1;
		return;
	}
	seeking = true;
	pauseD = false;
	IsPaused = false;
	sf_seek( snd, i * rate, SEEK_SET );
	seeking = false;
}

void stop()
{
	bolStop = true;
}

void togglePause()
{
	IsPaused = !IsPaused;
}

void getQmpLib( Qmp *_QLib )
{
	QLib = _QLib;
	QMPConf = QLib->getFileName( QMP_CONF );
	QOut = QLib->getOutLib();
}

void Init( bool b, int )
{
	BS = mustReset = false;
	if ( !b )
	{
		Save.odczytajopcje();
		fs.Init();
		fs.ApplyB();
	}
}

void clrSet()
{
	SongPos = 0;
	NumPos = 0;
	pltime = 0;
	plMaxtime = 0;
	if ( !BS )
		bolStop = false;
	else
		BS = false;
	IsPaused = seeking = nowReading = endSong = false;
	curF.clear();
	title.clear();
}

void clrPos()
{
	savsek = 0;
}

void savPos()
{
	savsek = SongPos;
}

void closePlug(bool x,bool z)
{
	mustReset = false;
	if ( !x && !z )
	{
		fs.setParent(NULL);
		fs.close();
		return;
	}
	if ( x )
		savPos();
	Save.zapiszopcje();
	BS = true;
	stop();
}

void showOptions()
{
	QWidget *qW = QLib->getParent(QMP_MAIN_OR_PLIST);
	fs.setParent( NULL );
	fs.move( qW->x() + qW->width()/2 - fs.width()/2 , qW->y() + qW->height()/2 - fs.height()/2 );
	fs.show();
}

void opcje(QWidget *w)
{
	if (w)
	{
		w->setMinimumSize( fs.minimumSize() );
		w->setMaximumSize( fs.maximumSize() );
		tmpWidget = w;
	}
	fs.setParent(tmpWidget);
	fs.move(0,0);
	fs.show();
}

const QString PlugInfoStr("Sndfile Input Plugin");
void about(QWidget *w)
{
	QMessageBox::information( w, PlugInfoStr, PlugInfoStr );
}

void getMusInfo( const char *fileE, uint type, int *time, QString *title )
{
	if ( type != 0 )
		return;
	SF_INFO sndInfo;
	SNDFILE *snd = sf_open( fileE, SFM_READ, &sndInfo );
	if ( !snd )
		return;

	getMusInfo( snd, title );

	if ( time )
		*time = sndInfo.frames / sndInfo.samplerate;

	sf_close( snd );
	return;
}

QString getMusStr(const char *fileE, int type, QPixmap &pix)
{
	QString musStr;
	pix = NULL;
	if ( type == 0 )
	{
		SF_INFO sndInfo;
		SNDFILE *snd = sf_open( fileE, SFM_READ, &sndInfo );
		if ( !snd )
			return musStr;

		const char *tmp;
		tmp = sf_get_string ( snd, SF_STR_ALBUM );
		if ( tmp )
			musStr += QString( "\nAlbum	" ) + tmp;
		tmp = sf_get_string ( snd, SF_STR_DATE );
		if ( tmp )
			musStr += QString( "\nYear	" ) + tmp;
		tmp = sf_get_string ( snd, SF_STR_COMMENT );
		if ( tmp )
			musStr += QString( "\nComment	" ) + tmp;

		sf_close( snd );
	}
	return musStr;
}

bool FileFormatSupport( const char *fileE )
{
	SF_INFO sndInfo;
	SNDFILE *snd = sf_open( fileE, SFM_READ, &sndInfo );
	if ( !snd )
		return false;
	sf_close( snd );
	return true;
}

void infoWindow( QWidget *w, const char *fileE, int type )
{
	if ( type != 0 )
		return;
	QString sd = "Path	\"" + QFile::decodeName(fileE) + "\"";

	SF_INFO sndInfo;
	SNDFILE *snd = sf_open( fileE, SFM_READ, &sndInfo );
	if ( snd )
	{
		sd += "\nSamplerate	" + QString::number( sndInfo.samplerate );
		sd += "\nChannels	" + QString::number( sndInfo.channels );
		sd += "\nFormat	" + getFormatStr( sndInfo.format );
		sf_close( snd );
	}

	QMessageBox::information( w, PlugInfoStr, sd );
}

bool SwOnOff( bool b )
{
	if (!b)
		return Enabled;
	fs.ui.enabledB->setChecked( !Enabled );
	fs.ApplyB();
	return 0;
}
