void opcje(QWidget*w)
{
	fs.setParent(w);
	fs.move(0,0);
	fs.show();
}

void Init(bool b, int rate, int bits, int chn, QString fName )
{
	if ( isOpen )
		closePlug(true);
	if ( b )
	{
		PlErr = false;

		if (!rate)
			rate=44100;
		if (!bits)
			bits=16;
		if (!chn)
			chn=2;

		bits2 = bits;

		if ( bits > 16 )
		{
			errStr = Texts[1];
			PlErr = true;
			return;
		}

		if ( !QFile::exists( fPth ) )
		{
			if ( !QDir().mkpath( fPth ) )
			{
				errStr = Texts[0];
				PlErr = true;
				return;
			}
		}

		if ( raw )
			ext = ".pcm";
		else
			ext = ".wav";

		fName = getFileName( fName, fPth + "/", ext );
		file = fopen( QFile::encodeName( fPth + "/" + fName + ext ), "wb" );
		if ( !file )
		{
			errStr = Texts[0];
			PlErr = true;
			return;
		}

		if ( !raw )
		{
			char x[45];

			sprintf(x,"%s%c%c%c%c%s%s%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%s%c%c%c%c",
			"RIFF",
			0,0,0,0, //fsize
			"WAVE",
			"fmt ",
			16,0,0,0,
			1,0,
			chn,0,
			0,0,0,0, //samplerate
			0,0,0,0, //samplerate*chn*bits/8
			(chn * bits / 8),0,
			bits,0,
			"data",
			0,0,0,0 //datasize
			);

			fwrite(x,sizeof(x),1,file);
			fseek(file,-1,1);

			write4b( rate,24 );
			write4b( (rate*chn*bits/8),28 );
		}
		fflush(file);

		isOpen=true;
	}
	else
	{
		Save.odczytajopcje();
		isOpen=false;
		fs.Init();
	}
}

void closePlug(bool b)
{
	if (isOpen)
	{
		if ( file )
		{
			if ( !raw )
			{
				write4b( getFLen(), 4 );
				write4b( getDLen(), 40 );
			}
			fclose(file);
		}
	}
	isOpen=false;
	if (!b)
	{
		fs.setParent(NULL);
		fs.close();
	}
}

void convertSignedToUnsignedPCM( char *audio_buffer, int buff )
{
	for (int i = 0 ; i < buff ; i++)
	{
		if ( audio_buffer[i] == 0 )
		{
			audio_buffer[i] = 0x80;
			continue;
		}
		if ( audio_buffer[i] < 0 )
		{
			audio_buffer[i] += 0x80;
			continue;
		}
		if ( audio_buffer[i] > 0 )
		{
			audio_buffer[i] -= 0x80;
			continue;
		}
	}
}

void play(char *audio_buffer,int buff)
{
	if ( !file || !isOpen )
		return;

	if ( sch || bits2 != 8 )
	{
		fwrite(audio_buffer,1,buff,file);
		return;
	}

	if ( !sch && bits2 == 8 )
	{
		convertSignedToUnsignedPCM( audio_buffer, buff );
		fwrite(audio_buffer,1,buff,file);
	}
}

void setLang(QString langfile)
{
	Texts.clear();

	QMPset = new QSettings( langfile , QSettings::IniFormat );

	for ( int i = 0 ; i < langCount ; i++ )
		Texts += QString::fromUtf8( QMPset->value( "QExport/" + QString::number(i) ).toString().toAscii() );

	fs.ui.label->setText( QString::fromUtf8( QMPset->value( "QExportWindow/0" ).toString().toAscii() ) );
	fs.ui.browseB->setText( QString::fromUtf8( QMPset->value( "QExportWindow/1" ).toString().toAscii() ) );
	fs.ui.rawB->setText( QString::fromUtf8( QMPset->value( "QExportWindow/2" ).toString().toAscii() ) );
	fs.ui.schB->setText( QString::fromUtf8( QMPset->value( "QExportWindow/3" ).toString().toAscii() ) );
	fs.ui.ApplyB->setText( QString::fromUtf8( QMPset->value( "QExportWindow/4" ).toString().toAscii() ) );

	delete QMPset;
}

void getQmpLib( Qmp *_QLib )
{
	QLib = _QLib;
	QMPConf = QLib->getFileName( QMP_CONF );
}
