const int langCount = 132+1;
QStringList lnglist[2];

void FormLang::Init()
{
	QStringList files;
	QDir dir;

	lnglist[0].clear();
	lnglist[1].clear();
	files.clear();

	dir.cd(qApp->applicationDirPath()+"/lang");
	files = dir.entryList( (QStringList)"*.qmplang" , QDir::Files );

	for ( int i = 0 ; i < files.size() ; i++ )
	{
		QMPset = new QSettings( "lang/"+files[i] , QSettings::IniFormat );

		if ( !QMPset->value("QMPLng/QMPLng").toBool() || QMPset->value("QMPLng/QMPVer").toUInt() != QMPlayLangVer )
		{
			delete QMPset;
			continue;
		}

		lnglist[0] += QMPset->value("QMPLng/Lang").toString();
		lnglist[1] += "lang/"+files[i];

		delete QMPset;
	}

	ui.langCB->clear();
	ui.langCB->addItems( lnglist[0] );

	setIndex();
}

void FormLang::setIndex()
{
	ui.langCB->setCurrentIndex( 0 );
	for ( int i = 0 ; i < ui.langCB->count() ; i++ )
	{
		if ( ui.langCB->itemText( i ).contains( language , Qt::CaseInsensitive ) )
		{
			ui.langCB->setCurrentIndex( i );
			break;
		}
	}
}

void FormLang::zamknij()
{
	setLang();
	setLangLibs();

	close();
}

void FormLang::setLang()
{
	QMPset = new QSettings( lnglist[1][ui.langCB->currentIndex()] , QSettings::IniFormat );

	Texts.clear();

	for ( int i = 0 ; i < langCount ; i++ )
		Texts += QString::fromUtf8( QMPset->value( "QMP/" + QString::number(i) ).toString().toAscii() );

	Texts[7]  += " "+QMPVersion;
	Texts[29] += " "+QMPVersion;

	formInfo.setObjectName( Texts[125] /* Informacje o muzyce */ );

	f1.ui.quitButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/0" ).toString().toAscii() ) );
	f1.ui.actionZakoncz->setText( QString::fromUtf8( QMPset->value( "MainWindow/0" ).toString().toAscii() ) );
	f1.ui.actionInformacje_2->setText( QString::fromUtf8( QMPset->value( "MainWindow/1" ).toString().toAscii() ) );
	f1.ui.act_funkcje->setText( QString::fromUtf8( QMPset->value( "MainWindow/2" ).toString().toAscii() ) );
	f1.ui.actionAB->setText( QString::fromUtf8( QMPset->value( "MainWindow/3" ).toString().toAscii() ) );
	f1.ui.actionOpcje->setText( QString::fromUtf8( QMPset->value( "MainWindow/4" ).toString().toAscii() ) );
	f1.ui.opcjeButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/4" ).toString().toAscii() ) );
	f1.ui.actionInformacje->setText( QString::fromUtf8( QMPset->value( "MainWindow/5" ).toString().toAscii() ) );
	f1.ui.actionSHPlist->setText( QString::fromUtf8( QMPset->value( "MainWindow/6" ).toString().toAscii() ) );
	f1.ui.NewPLAct->setText( QString::fromUtf8( QMPset->value( "MainWindow/7" ).toString().toAscii() ) );
	f1.ui.menuAkcja->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/8" ).toString().toAscii() ) );
	f1.ui.actionClrplist->setText( QString::fromUtf8( QMPset->value( "MainWindow/9" ).toString().toAscii() ) );
	f1.ui.actionWyszukaj->setText( QString::fromUtf8( QMPset->value( "MainWindow/10" ).toString().toAscii() ) );
	f1.ui.wlasciwosciA->setText( QString::fromUtf8( QMPset->value( "MainWindow/11" ).toString().toAscii() ) );
	f1.ui.selMusA->setText( QString::fromUtf8( QMPset->value( "MainWindow/12" ).toString().toAscii() ) );
	f1.ui.ukryjA->setText( QString::fromUtf8( QMPset->value( "MainWindow/13" ).toString().toAscii() ) );
	f1.ui.actionPlaylista->setText( QString::fromUtf8( QMPset->value( "MainWindow/14" ).toString().toAscii() ) );
	f1.ui.actionPlaylista_2->setText( QString::fromUtf8( QMPset->value( "MainWindow/14" ).toString().toAscii() ) );
	f1.ui.a_savMus->setText( QString::fromUtf8( QMPset->value( "MainWindow/15" ).toString().toAscii() ) );
	f1.ui.actionMuzyka->setText( QString::fromUtf8( QMPset->value( "MainWindow/15" ).toString().toAscii() ) );
	f1.ui.netA->setText( QString::fromUtf8( QMPset->value( "MainWindow/16" ).toString().toAscii() ) );
	f1.ui.vup_a->setText( QString::fromUtf8( QMPset->value( "MainWindow/17" ).toString().toAscii() ) );
	f1.ui.vdwn_a->setText( QString::fromUtf8( QMPset->value( "MainWindow/18" ).toString().toAscii() ) );
	f1.ui.pwp_a->setText( QString::fromUtf8( QMPset->value( "MainWindow/19" ).toString().toAscii() ) );
	f1.ui.pwl_a->setText( QString::fromUtf8( QMPset->value( "MainWindow/20" ).toString().toAscii() ) );
	f1.ui.actionBrak->setText( QString::fromUtf8( QMPset->value( "MainWindow/21" ).toString().toAscii() ) );
	f1.ui.actionLosowo->setText( QString::fromUtf8( QMPset->value( "MainWindow/22" ).toString().toAscii() ) );
	f1.ui.actionPowtarzanie_utworu->setText(QString::fromUtf8(QMPset->value( "MainWindow/23").toString().toAscii()) );
	f1.ui.actionPowtarzanie_listy->setText(QString::fromUtf8(QMPset->value( "MainWindow/24").toString().toAscii()) );
	f1.ui.actionDo_ty_u->setText( QString::fromUtf8( QMPset->value( "MainWindow/25" ).toString().toAscii() ) );
	f1.ui.playlistButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/26" ).toString().toAscii() ) );
	f1.ui.playButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/27" ).toString().toAscii() ) );
	f1.ui.pauseButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/28" ).toString().toAscii() ) );
	f1.ui.stopButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/29" ).toString().toAscii() ) );
	f1.ui.prevButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/30" ).toString().toAscii() ) );
	f1.ui.nextButton->setText( QString::fromUtf8( QMPset->value( "MainWindow/31" ).toString().toAscii() ) );
	f1.ui.actionPlay->setText( QString::fromUtf8( QMPset->value( "MainWindow/27" ).toString().toAscii() )+"	(X)" );
	f1.ui.actionPause->setText( QString::fromUtf8( QMPset->value( "MainWindow/28" ).toString().toAscii() )+"	(C)" );
	f1.ui.actionStop->setText( QString::fromUtf8( QMPset->value( "MainWindow/29" ).toString().toAscii() )+"	(V)" );
	f1.ui.actionPrevious->setText(QString::fromUtf8( QMPset->value( "MainWindow/52").toString().toAscii() )+"	(Z)" );
	f1.ui.actionNext->setText( QString::fromUtf8( QMPset->value( "MainWindow/53" ).toString().toAscii() )+"	(B)" );
	f1.ui.menuPomoc->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/32" ).toString().toAscii() ) );
	f1.ui.menuInne->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/33" ).toString().toAscii() ) );
	f1.ui.menuPlaylista->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/34" ).toString().toAscii() ) );
	f1.ui.menuOdtwarzacz->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/35" ).toString().toAscii() ) );
	f1.ui.menuPlik->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/36" ).toString().toAscii() ) );
	f1.ui.menuOtw_rz->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/37" ).toString().toAscii() ) );
	f1.ui.menuZapisz->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/38" ).toString().toAscii() ) );
	f1.ui.menuOperacje->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/39" ).toString().toAscii() ) );
	f1.ui.menuPowtarzanie_utworu->setTitle(QString::fromUtf8( QMPset->value( "MainWindow/40").toString().toAscii()));
	f1.ui.delWpisyA->setText( QString::fromUtf8( QMPset->value( "MainWindow/41" ).toString().toAscii() ) );
	f1.ui.actionWklej->setText( QString::fromUtf8( QMPset->value( "MainWindow/42" ).toString().toAscii() ) + "	Ctrl+V" );
	f1.ui.actionZa_aduj->setText( QString::fromUtf8( QMPset->value( "MainWindow/43" ).toString().toAscii() ) + "	Enter" );
	f1.ui.actionZapisz->setText( QString::fromUtf8( QMPset->value( "MainWindow/44" ).toString().toAscii() ) + "	Alt+S" );
	f1.ui.actionZmie_nazw->setText( QString::fromUtf8( QMPset->value( "MainWindow/45" ).toString().toAscii() ) + "	Ctrl+R" );
	f1.ui.actionDodaj_list->setText( QString::fromUtf8( QMPset->value( "MainWindow/46" ).toString().toAscii() ) );
	f1.ui.actionUsu_list->setText( QString::fromUtf8( QMPset->value( "MainWindow/47" ).toString().toAscii() ) );
	f1.ui.actionCzy_listy->setText( QString::fromUtf8( QMPset->value( "MainWindow/48" ).toString().toAscii() ) );
	f1.ui.menuLista_playlist->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/49" ).toString().toAscii() ) );
	f1.ui.sizeA->setText( QString::fromUtf8( QMPset->value( "MainWindow/50" ).toString().toAscii() ) );
	f1.ui.updatesA->setText( QString::fromUtf8( QMPset->value( "MainWindow/51" ).toString().toAscii() ) );
	f1.ui.plistA->setText( QString::fromUtf8( QMPset->value( "MainWindow/52" ).toString().toAscii() ) );
	f1.ui.nlistA->setText( QString::fromUtf8( QMPset->value( "MainWindow/53" ).toString().toAscii() ) );
	f1.ui.eqB->setText( QString::fromUtf8( QMPset->value( "MainWindow/54" ).toString().toAscii() ) );
	f1.ui.actionOd_wie->setText( QString::fromUtf8( QMPset->value( "MainWindow/55" ).toString().toAscii() ) );
	f1.ui.actionZatrzymaj->setText( QString::fromUtf8( QMPset->value( "MainWindow/56" ).toString().toAscii() ) );
	f1.ui.actionDir->setText( QString::fromUtf8( QMPset->value( "MainWindow/57" ).toString().toAscii() ) );
	f1.ui.infoB->setText( QString::fromUtf8( QMPset->value( "MainWindow/58" ).toString().toAscii() ) );
	f1.ui.actionZaznacz->setText( QString::fromUtf8( QMPset->value( "MainWindow/59" ).toString().toAscii() ) );
	f1.ui.actionOdznacz->setText( QString::fromUtf8( QMPset->value( "MainWindow/60" ).toString().toAscii() ) );
	f1.ui.actionKopiuj->setText( QString::fromUtf8( QMPset->value( "MainWindow/61" ).toString().toAscii() ) + "	Ctrl+C" );
	f1.ui.miniVersionB->setToolTip( QString::fromUtf8( QMPset->value( "MainWindow/62" ).toString().toAscii() ) );
	f1.ui.menuSortuj->setTitle( QString::fromUtf8( QMPset->value( "MainWindow/63" ).toString().toAscii() ) );
	f1.ui.actionSortMod->setText( QString::fromUtf8( QMPset->value( "MainWindow/64" ).toString().toAscii() ) );
	f1.ui.actionSortTitle->setText( QString::fromUtf8( QMPset->value( "MainWindow/65" ).toString().toAscii() ) );
	f1.ui.actionSortLength->setText( QString::fromUtf8( QMPset->value( "MainWindow/66" ).toString().toAscii() ) );
	f1.ui.copyTitleA->setText( QString::fromUtf8( QMPset->value( "MainWindow/67" ).toString().toAscii() ) );

	fs.ui.applyButton->setText( QString::fromUtf8( QMPset->value( "SetupWindow/0" ).toString().toAscii() ) );
	fs.ui.langB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/1" ).toString().toAscii() ) );
	fs.ui.OKButton->setText( QString::fromUtf8( QMPset->value( "SetupWindow/2" ).toString().toAscii() ) );
	fs.ui.loadPlugButton->setText( QString::fromUtf8( QMPset->value( "SetupWindow/3" ).toString().toAscii() ) );
	fs.ui.abPB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/4" ).toString().toAscii() ) );
	fs.ui.opcjePB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/5" ).toString().toAscii() ) );
	fs.ui.setStyleB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/6" ).toString().toAscii() ) );
	fs.ui.delSetsButton->setText( QString::fromUtf8( QMPset->value( "SetupWindow/7" ).toString().toAscii() ) );
	fs.ui.tabWidget_2->setTabText( 2, QString::fromUtf8( QMPset->value( "SetupWindow/8" ).toString().toAscii() ) );
	fs.ui.updB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/9" ).toString().toAscii() ) );
	fs.ui.fileStructB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/10" ).toString().toAscii() ) );
	fs.ui.label_f->setText( QString::fromUtf8( QMPset->value( "SetupWindow/11" ).toString().toAscii() ) );
	fs.ui.naf1Box->setText( QString::fromUtf8( QMPset->value( "SetupWindow/12" ).toString().toAscii() ) );
	fs.ui.zVpluginaB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/13" ).toString().toAscii() ) );
	fs.ui.zIpluginaB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/14" ).toString().toAscii() ) );
	fs.ui.defB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/15" ).toString().toAscii() ) );
	fs.ui.label_o->setText( QString::fromUtf8( QMPset->value( "SetupWindow/16" ).toString().toAscii() ) );
	fs.ui.NxterrBox->setText( QString::fromUtf8( QMPset->value( "SetupWindow/17" ).toString().toAscii() ) );
	fs.ui.PlaynxtBox->setText( QString::fromUtf8( QMPset->value( "SetupWindow/18" ).toString().toAscii() ) );
	fs.ui.savplistBox->setText( QString::fromUtf8( QMPset->value( "SetupWindow/19" ).toString().toAscii() ) );
	fs.ui.pbLBox->setText( QString::fromUtf8( QMPset->value( "SetupWindow/20" ).toString().toAscii() ) );
	fs.ui.pbRBox->setText( QString::fromUtf8( QMPset->value( "SetupWindow/21" ).toString().toAscii() ) );
	fs.ui.savposBox->setText( QString::fromUtf8( QMPset->value( "SetupWindow/22" ).toString().toAscii() ) );
	fs.ui.closeExportOnNxtB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/23" ).toString().toAscii() ) );
	fs.ui.pmppB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/24" ).toString().toAscii() ) );
	fs.ui.label->setText( QString::fromUtf8( QMPset->value( "SetupWindow/25" ).toString().toAscii() ) );
	fs.ui.bladinfoB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/26" ).toString().toAscii() ) );
	fs.ui.tabWidget->setTabText( 0, QString::fromUtf8( QMPset->value( "SetupWindow/27" ).toString().toAscii() ) );
	fs.ui.uPLeLB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/28" ).toString().toAscii() ) );
	fs.ui.uPLeB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/29" ).toString().toAscii() ) );
	fs.ui.QMPButton->setText( QString::fromUtf8( QMPset->value( "SetupWindow/30" ).toString().toAscii() ) );
	fs.ui.tabWidget->setTabText( 1, QString::fromUtf8( QMPset->value( "SetupWindow/31" ).toString().toAscii() ) );
	fs.ui.tabWidget->setTabText( 2, QString::fromUtf8( QMPset->value( "SetupWindow/32" ).toString().toAscii() ) );
	fs.ui.tabWidget_2->setTabText( 0, QString::fromUtf8( QMPset->value( "SetupWindow/33" ).toString().toAscii() ) );
	fs.ui.tabWidget_2->setTabText( 1, QString::fromUtf8( QMPset->value( "SetupWindow/34" ).toString().toAscii() ) );
	fs.ui.dockB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/35" ).toString().toAscii() ) );
	fs.ui.label_2->setText( QString::fromUtf8( QMPset->value( "SetupWindow/36" ).toString().toAscii() ) );
	fs.ui.label_3->setText( QString::fromUtf8( QMPset->value( "SetupWindow/37" ).toString().toAscii() ) );
	fs.ui.label_7->setText( QString::fromUtf8( QMPset->value( "SetupWindow/38" ).toString().toAscii() ) );
	fs.ui.proxyB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/39" ).toString().toAscii() ) );
	fs.ui.fileFilterB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/40" ).toString().toAscii() ) );
	fs.ui.chImgsB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/41" ).toString().toAscii() ) );
	fs.ui.eoplB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/42" ).toString().toAscii() ) );
	fs.ui.autoUpdatesB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/43" ).toString().toAscii() ) );
	fs.ui.svrAddressRestoreB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/44" ).toString().toAscii() ) );
	fs.ui.unknownTypeB->setText( QString::fromUtf8( QMPset->value( "SetupWindow/45" ).toString().toAscii() ) );

	fdck.setWindowTitle( QString::fromUtf8( QMPset->value( "SetupWindow/35" ).toString().toAscii() ) );

	fa.ui.label_6->setText( QString::fromUtf8( QMPset->value( "AboutWindow/0" ).toString().toAscii() ) );
	fa.ui.label_5->setText( QString::fromUtf8( QMPset->value( "AboutWindow/1" ).toString().toAscii() ) );
	fa.ui.label_3->setText( QString::fromUtf8( QMPset->value( "AboutWindow/2" ).toString().toAscii() ) );
	fa.ui.cleanB->setText( QString::fromUtf8( QMPset->value( "AboutWindow/3" ).toString().toAscii() ) );
	fa.ui.refB->setText( QString::fromUtf8( QMPset->value( "AboutWindow/4" ).toString().toAscii() ) );
	fa.ui.OKB->setText( QString::fromUtf8( QMPset->value( "AboutWindow/5" ).toString().toAscii() ) );

	ff.ui.closeB->setText( QString::fromUtf8( QMPset->value( "FunctionWindow/0" ).toString().toAscii() ) );

	fcp.ui.brB->setText( QString::fromUtf8( QMPset->value( "CopyWindow/0" ).toString().toAscii() ) );

	fp.ui.addButton->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/0" ).toString().toAscii() ) );
	fp.ui.actButton->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/1" ).toString().toAscii() ) );
	fp.ui.odczytajB->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/2" ).toString().toAscii() ) );
	fp.ui.delButton->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/3" ).toString().toAscii() ) );
	fp.ui.clrButton->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/4" ).toString().toAscii() ) );
	fp.ui.zapiszB->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/5" ).toString().toAscii() ) );
	fp.ui.listPlaylstBox->setText( QString::fromUtf8( QMPset->value( "PlayListWindow/6" ).toString().toAscii() ) );
	fp.ui.infoMB->setText( QString::fromUtf8( QMPset->value( "MainWindow/58" ).toString().toAscii() ) );

	fpr.ui.label_4->setText( QString::fromUtf8( QMPset->value( "PropWindow/0" ).toString().toAscii() ) );
	fpr.ui.label_3->setText( QString::fromUtf8( QMPset->value( "PropWindow/1" ).toString().toAscii() ) );
	fpr.ui.label->setText( QString::fromUtf8( QMPset->value( "PropWindow/2" ).toString().toAscii() ) );
	fpr.ui.label_6->setText( QString::fromUtf8( QMPset->value( "PropWindow/3" ).toString().toAscii() ) );
	fpr.ui.label_2->setText( QString::fromUtf8( QMPset->value( "PropWindow/4" ).toString().toAscii() ) );
	fpr.ui.label_5->setText( QString::fromUtf8( QMPset->value( "PropWindow/5" ).toString().toAscii() ) );
	fpr.ui.applyTB->setText( QString::fromUtf8( QMPset->value( "PropWindow/6" ).toString().toAscii() ) );
	fpr.ui.applyB->setText( QString::fromUtf8( QMPset->value( "PropWindow/6" ).toString().toAscii() ) );
	fpr.ui.OKB->setText( QString::fromUtf8( QMPset->value( "PropWindow/7" ).toString().toAscii() ) );
	fpr.ui.fileB->setText( QString::fromUtf8( QMPset->value( "PropWindow/8" ).toString().toAscii() ) );
	fpr.ui.pluginB->setText( QString::fromUtf8( QMPset->value( "PropWindow/9" ).toString().toAscii() ) );
	fpr.ui.adresB->setText( QString::fromUtf8( QMPset->value( "PropWindow/10" ).toString().toAscii() ) );
	fpr.ui.groupBox->setTitle( QString::fromUtf8( QMPset->value( "PropWindow/11" ).toString().toAscii() ) );

	fl.setWindowTitle( QString::fromUtf8( QMPset->value( "SetupWindow/1" ).toString().toAscii() ) );

	fst.setWindowTitle( QString::fromUtf8( QMPset->value( "SetupWindow/6" ).toString().toAscii() ) );
	fst.ui.label->setText( QString::fromUtf8( QMPset->value( "StyleWindow/0" ).toString().toAscii() ) );
	fst.ui.scB->setText( QString::fromUtf8( QMPset->value( "StyleWindow/1" ).toString().toAscii() ) );
	fst.ui.ccB->setText( QString::fromUtf8( QMPset->value( "StyleWindow/2" ).toString().toAscii() ) );
	fst.ui.label_2->setText( QString::fromUtf8( QMPset->value( "StyleWindow/3" ).toString().toAscii() ) );
	fst.ui.addB->setText( QString::fromUtf8( QMPset->value( "StyleWindow/4" ).toString().toAscii() ) );
	fst.ui.delB->setText( QString::fromUtf8( QMPset->value( "StyleWindow/5" ).toString().toAscii() ) );
	fst.ui.label_3->setText( QString::fromUtf8( QMPset->value( "StyleWindow/6" ).toString().toAscii() ) );
	fst.ui.chNameB->setText( QString::fromUtf8( QMPset->value( "StyleWindow/7" ).toString().toAscii() ) );
	fst.ui.applyColorsB->setText( QString::fromUtf8( QMPset->value( "StyleWindow/8" ).toString().toAscii() ) );
	fst.ui.label_4->setText( QString::fromUtf8( QMPset->value( "StyleWindow/9" ).toString().toAscii() ) );
	fst.ui.label_5->setText( QString::fromUtf8( QMPset->value( "StyleWindow/10" ).toString().toAscii() ) );
	fst.ui.label_6->setText( QString::fromUtf8( QMPset->value( "StyleWindow/11" ).toString().toAscii() ) );
	fst.ui.label_7->setText( QString::fromUtf8( QMPset->value( "StyleWindow/12" ).toString().toAscii() ) );
	fst.ui.label_8->setText( QString::fromUtf8( QMPset->value( "StyleWindow/13" ).toString().toAscii() ) );
	fst.ui.label_14->setText( QString::fromUtf8( QMPset->value( "StyleWindow/14" ).toString().toAscii() ) );
	fst.ui.label_16->setText( QString::fromUtf8( QMPset->value( "StyleWindow/15" ).toString().toAscii() ) );
	fst.ui.use2->setText( QString::fromUtf8( QMPset->value( "StyleWindow/16" ).toString().toAscii() ) );
	fst.ui.label_9->setText( QString::fromUtf8( QMPset->value( "StyleWindow/17" ).toString().toAscii() ) );
	fst.ui.label_10->setText( QString::fromUtf8( QMPset->value( "StyleWindow/18" ).toString().toAscii() ) );
	fst.ui.bHt2->setText( QString::fromUtf8( QMPset->value( "StyleWindow/19" ).toString().toAscii() ) );
	fst.ui.bSt2->setText( QString::fromUtf8( QMPset->value( "StyleWindow/20" ).toString().toAscii() ) );
	fst.ui.tabWidget->setTabText( 0, QString::fromUtf8( QMPset->value( "StyleWindow/21" ).toString().toAscii() ) );
	fst.ui.tabWidget->setTabText( 1, QString::fromUtf8( QMPset->value( "StyleWindow/22" ).toString().toAscii() ) );
	fst.ui.label_17->setText( QString::fromUtf8( QMPset->value( "StyleWindow/23" ).toString().toAscii() ) );

	formInfo.button->setText( Texts[66]/**Zamknij*/ );

	searchAction->setText( Texts[11]/**Wyszukuj we wszystkich playlistach*/ );

	language = lnglist[0][ui.langCB->currentIndex()];
	langFile = lnglist[1][ui.langCB->currentIndex()];

	delete QMPset;

	if ( pluginsLoaded )
		f1.setShortCutsandOthers();
}

void FormLang::setLangLibs()
{
	QOut->setLang( langFile );
	if ( equalizer && equalizer->setLang )
		equalizer->setLang( langFile );
	if ( QExport && QExport->setLang )
			QExport->setLang( langFile );
	int w;
	for ( w = 0 ; w < Iplugins.size() ; w++ )
		if ( Iplugins[w]->setLang )
			Iplugins[w]->setLang( langFile );
	for ( w = 0 ; w < Oplugins.size() ; w++ )
		if ( Oplugins[w]->setLang )
			Oplugins[w]->setLang( langFile );
	for ( w = 0 ; w < Eplugins.size() ; w++ )
		if ( Eplugins[w]->setLang )
			Eplugins[w]->setLang( langFile );
	for ( w = 0 ; w < Vplugins.size() ; w++ )
		if ( Vplugins[w]->setLang )
			Vplugins[w]->setLang( langFile );
	for ( w = 0 ; w < Fplugins.size() ; w++ )
		if ( Fplugins[w]->setLang )
			Fplugins[w]->setLang( langFile );
}
